// tcp.c
// $Id: tcp.c,v 1.2 2007/10/17 11:01:38 sendan Exp $
// masashi shimakura

#include<stdio.h>
#include<unistd.h>
#include<fcntl.h>
#include<sys/socket.h>
#include<netinet/in_systm.h>
#include<netinet/in.h>
#include<netinet/ip.h>
#include<arpa/inet.h>
#include<stdlib.h>
#include<string.h>
#include<errno.h>
#include<pthread.h>

#include "sitar.h"
#include"almemsys.h"

struct sockaddr_in my_addr;

extern global_data_t gd;

/*
int socket_bind(int, char []);
int socket_connect(int, char []);
int socket_accept(void);
*/




/*------------------ BIND ----------------------*/
int socket_bind(int port, char ip_addr[])
{
if((gd.ip.ls = socket(AF_INET, SOCK_STREAM, 0))==-1){
   fprintf(stderr,"socket_bind(1): Not cleate socket \n");
   safe_exit("socket_bind(): socket exit \n");
   }

my_addr.sin_family = AF_INET;
my_addr.sin_port = htons(port);
my_addr.sin_addr.s_addr = inet_addr(ip_addr);

if(bind(gd.ip.ls, (struct sockaddr *)(int)&my_addr, sizeof(my_addr)) == -1){
   fprintf(stderr,"socket_bind(2): Not bind addrses\n");
   close(gd.ip.ls);
   safe_exit("socket_bind(): bind exit \n");
   }

if((listen(gd.ip.ls,1))==-1){
   fprintf(stderr,"socket_bind(3): Not listen port\n");
   close(gd.ip.ls);
   safe_exit("socket_bind(): listn exit \n");
   }
return 0;
}



/*----------------------- CONNECT --------------------*/
int socket_connect(int port, char ip_addr[])
{
int ret;

ret = 0;
if((gd.ip.sk = socket(AF_INET, SOCK_STREAM, 0))==-1){
   fprintf(stderr,"socket_connect(): Not cleate socket\n");
   ret = -1;
   return(ret); 
   }

my_addr.sin_family = AF_INET;
my_addr.sin_port = htons(port);
my_addr.sin_addr.s_addr = inet_addr(ip_addr);

if(connect(gd.ip.sk, (struct sockaddr *)(int)&my_addr, sizeof(my_addr)) == -1){
   fprintf(stderr,"socket_connect(): Not connection\n");
   close(gd.ip.sk);
   ret = -1;
   return(ret); 
   }

return(ret);
}




/*--------------------- ACCEPT -------------------*/
int socket_accept(void)
{
gd.ip.my_addrlen = sizeof(my_addr);
if((gd.ip.sk=accept(gd.ip.ls, (struct sockaddr *)(int)&my_addr, &gd.ip.my_addrlen)) == -1){
   fprintf(stderr,"socket_sccept(): Not scception\n");
   safe_exit("socket_accept() exit \n");
   close(gd.ip.ls);
   }
return 0;
}




